/*
  For more information, please see: http://software.sci.utah.edu
  
  The MIT License

  Copyright (c) 2009 Scientific Computing and Imaging Institute,
  University of Utah.


  Permission is hereby granted, free of charge, to any person obtaining a 
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation 
  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
  and/or sell copies of the Software, and to permit persons to whom the 
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included 
  in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
  DEALINGS IN THE SOFTWARE.
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        cropvolume.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     20/08/2007 08:51:42
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), 20/08/2007 08:51:42

#ifndef _CROPVOLUME_H_
#define _CROPVOLUME_H_

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/spinctrl.h"
////@end includes
#include "wx/spinctrl.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CROPVOLUME 10021
#define SYMBOL_CROPVOLUME_STYLE 0
#define SYMBOL_CROPVOLUME_TITLE _("CropVolume")
#define SYMBOL_CROPVOLUME_IDNAME ID_CROPVOLUME
#define SYMBOL_CROPVOLUME_SIZE wxSize(200, -1)
#define SYMBOL_CROPVOLUME_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CropVolume class declaration
 */

struct CropSetRangeStruct {
  int min_x, min_y, min_z;
  int max_x, max_y, max_z;
};


class CropVolume: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CropVolume )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CropVolume();
    CropVolume( wxWindow* parent, wxWindowID id = SYMBOL_CROPVOLUME_IDNAME, const wxPoint& pos = SYMBOL_CROPVOLUME_POSITION, const wxSize& size = SYMBOL_CROPVOLUME_SIZE, long style = SYMBOL_CROPVOLUME_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CROPVOLUME_IDNAME, const wxPoint& pos = SYMBOL_CROPVOLUME_POSITION, const wxSize& size = SYMBOL_CROPVOLUME_SIZE, long style = SYMBOL_CROPVOLUME_STYLE );

    /// Destructor
    ~CropVolume();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();
	void OnCropSetRange( wxCommandEvent& event );
	void OnCropSetMinMax( wxCommandEvent& event );
	void OnStartButtonClick( wxCommandEvent& event );	
	void OnCloseButtonClick( wxCommandEvent& event );
    void OnSpinMinX (wxSpinEvent &event);
    void OnSpinMaxX (wxSpinEvent &event);
    void OnSpinMinY (wxSpinEvent &event);
    void OnSpinMaxY (wxSpinEvent &event);
    void OnSpinMinZ (wxSpinEvent &event);
    void OnSpinMaxZ (wxSpinEvent &event);

////@begin CropVolume event handler declarations

////@end CropVolume event handler declarations

////@begin CropVolume member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CropVolume member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CropVolume member variables
    wxSpinCtrl* mSpinMinX;
    wxSpinCtrl* mSpinMaxX;
    wxSpinCtrl* mSpinMinY;
    wxSpinCtrl* mSpinMaxY;
    wxSpinCtrl* mSpinMinZ;
    wxSpinCtrl* mSpinMaxZ;
////@end CropVolume member variables
};

#endif
    // _CROPVOLUME_H_
