/*
  For more information, please see: http://software.sci.utah.edu
  
  The MIT License

  Copyright (c) 2009 Scientific Computing and Imaging Institute,
  University of Utah.


  Permission is hereby granted, free of charge, to any person obtaining a 
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation 
  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
  and/or sell copies of the Software, and to permit persons to whom the 
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included 
  in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
  DEALINGS IN THE SOFTWARE.
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        itkthresholdsegmentationlevelsetfilter.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     Thu 18 Feb 10:43:35 2010
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), Thu 18 Feb 10:43:35 2010

#ifndef _ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_H_
#define _ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/spinctrl.h"
////@end includes

class wxProgressDialog;


/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
class wxTextCtrl;
class wxCheckBox;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER 10013
#define SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_STYLE 0
#define SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_TITLE _("ITKThresholdSegmentationLevelSetFilter")
#define SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_IDNAME ID_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER
#define SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_SIZE wxSize(200, -1)
#define SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * ITKThresholdSegmentationLevelSetFilter class declaration
 */

class ITKThresholdSegmentationLevelSetFilter: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( ITKThresholdSegmentationLevelSetFilter )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    ITKThresholdSegmentationLevelSetFilter();
    ITKThresholdSegmentationLevelSetFilter( wxWindow* parent, wxWindowID id = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_IDNAME, const wxPoint& pos = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_POSITION, const wxSize& size = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_SIZE, long style = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_IDNAME, const wxPoint& pos = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_POSITION, const wxSize& size = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_SIZE, long style = SYMBOL_ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_STYLE );

    /// Destructor
    ~ITKThresholdSegmentationLevelSetFilter();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

	void OnSetSeedLayerButtonClick( wxCommandEvent& event );
	void OnSetDataLayerButtonClick( wxCommandEvent& event );
	void OnSetThresholdLayerButtonClick( wxCommandEvent& event );
	void OnStartButtonClick( wxCommandEvent& event );
	void OnStopButtonClick( wxCommandEvent& event );
	void OnCloseButtonClick( wxCommandEvent& event );
	void OnSetProgress( wxCommandEvent& event );

    void SpinRadius( wxSpinEvent &event);
    void UpdateRadius( wxCommandEvent &event);

////@begin ITKThresholdSegmentationLevelSetFilter event handler declarations

////@end ITKThresholdSegmentationLevelSetFilter event handler declarations

////@begin ITKThresholdSegmentationLevelSetFilter member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end ITKThresholdSegmentationLevelSetFilter member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin ITKThresholdSegmentationLevelSetFilter member variables
    wxSpinCtrl* mRadius;
    wxSpinCtrl* mMaxIterations;
    wxSpinCtrl* mCurvatureScale;
    wxSpinCtrl* mEdgeWeight;
    wxSpinCtrl* mSmoothIterations;
    wxSpinCtrl* mSmoothConductance;
    wxTextCtrl* mSmoothTimeStep;
    wxCheckBox* mReverseExpansion;
////@end ITKThresholdSegmentationLevelSetFilter member variables

    wxProgressDialog *progress_dialog_;
    bool aborted_;
};

#endif
    // _ITKTHRESHOLDSEGMENTATIONLEVELSETFILTER_H_
